﻿using System;
using System.Data.SQLite;
using System.Windows.Forms;
using System.Data;
using System.IO;

namespace Imagenes_archivo_sqlite
{
    class BajasaltasSQLITE{
        /// <summary>
        /// Constructor por defecto
        /// </summary>
        public BajasaltasSQLITE(){
        }
        /// <summary>
        /// Contructor con 
        /// argumentos
        /// </summary>
        /// <param name="RutaArchivo"></param>
        /// <param name="NombreArch"></param>
        /// <param name="Extension"></param>
        /// <param name="TipoArch"></param>
        public BajasaltasSQLITE(byte[] Archivo, String NombreArch, String Extension, String TipoArch){
            Archivo_       = Archivo;
            NombreArchivo_ = NombreArch;
            Extension_     = Extension;
            TipoArchivo_   = TipoArch;
        }
        private Byte[] Archivo_;
        private String RutaDB_;
        private String NombreArchivo_;
        private String Extension_;
        private String TipoArchivo_;
        /// <summary>
        /// Establece y devuelve
        /// la ruta de la  base
        /// de datos
        /// </summary>
        public String RutaBaseDatos {
            get { return RutaDB_; }
            set { RutaDB_ = value; }
        }

        //Sector de propiedades
        /// <summary>
        /// Establece y devuelve
        /// la nombre del archivo
        /// </summary>
        public String NombreArchivo {
            get { return NombreArchivo_; }
            set { NombreArchivo_ = value; }
        }
        /// <summary>
        /// Establece y devuelve
        /// la extesion del archivo
        /// </summary>
        public String Extesion
        {
            get { return Extension_; }
            set { Extension_ = value; }
        }
        /// <summary>
        /// Establece y devuelve
        /// El tipo de archivo
        /// </summary>
        public String TipoArchivo
        {
            get { return TipoArchivo_; }
            set { TipoArchivo_ = value; }
        }
        /// <summary>
        /// Agrega datos
        /// a la base de datos.
        /// </summary>
        public void AgregarDatos() {
            //Estableciendo la cenexion
            SQLiteConnection Conexion = new SQLiteConnection("Data Source="+RutaDB_+ ";Versión=3");
            Conexion.Open();
            SQLiteCommand Comando = new SQLiteCommand("INSERT INTO Archivo(NombArch,Extesion,TipoArch,Archivo) VALUES(@Nombres,@Extesions,@Tipos,@Archivos)",Conexion);
            Comando.Parameters.AddWithValue("@Nombres",NombreArchivo_);
            Comando.Parameters.AddWithValue("@Extesions", Extension_);
            Comando.Parameters.AddWithValue("@Tipos", TipoArchivo_);
            Comando.Parameters.AddWithValue("@Archivos", Archivo_);
            Comando.ExecuteNonQuery();
            Conexion.Close();
        }
        /// <summary>
        /// Metodo que 
        /// carga al objeto
        /// DataGridView
        /// </summary>
        /// <param name="Lista"></param>
        public void CargarTablas(DataGridView Lista) {
     
            try
            {

                DataSet Tabla = new DataSet();
                //DataTable Tabla = new DataTable(); 
                //BusquedaArch Tabla = new BusquedaArch();
                SQLiteConnection ConexionSqlite = new SQLiteConnection(@"Data Source=" + RutaDB_ + ";Versión=3");
                ConexionSqlite.Open();
                SQLiteDataAdapter Insertar = new SQLiteDataAdapter("SELECT Archivo.ID,Archivo.NombArch,Archivo.Extesion,Archivo.TipoArch FROM Archivo", ConexionSqlite);
                Insertar.Fill(Tabla, "TablBusqueda");
                Lista.DataSource = Tabla;
                ConexionSqlite.Close();
                Lista.DataMember = "TablBusqueda";
                if (Lista.ColumnCount > 0){
                    Lista.Columns[0].Visible = false;
                    Lista.Columns[1].HeaderText = "Nombre";
                    Lista.Columns[1].Width = 300;
                    Lista.Columns[2].HeaderText = "Extesion";
                    Lista.Columns[2].Width = 50;
                    Lista.Columns[3].HeaderText = "Tipo";
                    Lista.Columns[3].Width = 300;
                    Lista.AllowUserToAddRows = false;
                }

            }
            catch (Exception e){
                //MessageBox.Show(e.Source);  
            }
        }

        /// <summary>
        /// Recupera cadena de bytes desde la base de datos
        /// para escribir el archivo en el lugar
        /// donde se genera el ejecutable
        /// </summary>
        /// <param name="Id"></param>
        /// <param name="Nombre"></param>
        public void RecuparByt(string Id,string Nombre){
            try{
  
                Byte[] Archivo = new byte[0];
                DataTable Tabla = new DataTable();
                SQLiteConnection ConexionSqlite = new SQLiteConnection("Data Source="+RutaDB_+";Version=3");
                ConexionSqlite.Open();
                SQLiteDataAdapter comando = new SQLiteDataAdapter("SELECT Archivo FROM Archivo WHERE ID='"+ Id + "'", ConexionSqlite);
                comando.Fill(Tabla);
                DataRow Row;
                Row = Tabla.Rows[0];
                Archivo = ((byte[])Row[0]);
                File.WriteAllBytes(Application.StartupPath + @"\"+Nombre,Archivo );
                ConexionSqlite.Close();
            }
            catch (Exception e) {
                MessageBox.Show(e.Message);
            }
        }
        /// <summary>
        /// Simple buscador
        /// de nombre de archivos
        /// </summary>
        /// <param name="Datos"></param>
        /// <param name="textbuscar"></param>
        public void Buscar(DataGridView Datos, String textbuscar) {
            try{
                DataSet Tabla = new DataSet();
                SQLiteConnection ConexionSqlite = new SQLiteConnection(@"Data Source=" + RutaDB_ + ";Versión=3");
                ConexionSqlite.Open();
                SQLiteDataAdapter Insertar = new SQLiteDataAdapter("SELECT Archivo.ID,Archivo.NombArch,Archivo.Extesion,Archivo.TipoArch FROM Archivo WHERE Archivo.NombArch LIKE '%"+ textbuscar + "%'", ConexionSqlite);
                Insertar.Fill(Tabla, "TablBusqueda");
                Datos.DataSource = Tabla;
                ConexionSqlite.Close();
                Datos.DataMember = "TablBusqueda";
                if (Datos.ColumnCount > 0){
                    Datos.Columns[0].Visible = false;
                    Datos.Columns[1].HeaderText = "Nombre";
                    Datos.Columns[1].Width = 300;
                    Datos.Columns[2].HeaderText = "Extesion";
                    Datos.Columns[2].Width = 50;
                    Datos.Columns[3].HeaderText = "Tipo";
                    Datos.Columns[3].Width = 300;
                    Datos.AllowUserToAddRows = false;
                }
            }
            catch (Exception error) {

            }
        }
    }
}
