﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.SQLite;
using System.Diagnostics;

namespace Imagenes_archivo_sqlite
{
    public partial class Form1 : Form
    {
        public Form1(){
            InitializeComponent();
            //Agregando evento para abrir archivos
            agregarArchivoToolStripMenuItem.Click += agregarArchivoToolStripMenuItem_;
            this.Load += Form1_Load;
            dataGridView1.DoubleClick += DataGridView1_DoubleClick;
            Txtbuscar.Click += Txtbuscar_Click;
        }


        /// <summary>
        /// Para abrir el archivo al selecionar 
        /// en una de las listas
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void DataGridView1_DoubleClick(object sender, EventArgs e){
            AbrirArchivo();
        }

        //Campos
        private String RutaDB= Application.StartupPath + @"\basededatos.db";
        private void Form1_Load(object sender, EventArgs e){
            BajasaltasSQLITE AgregarDatos = new BajasaltasSQLITE();
            AgregarDatos.RutaBaseDatos = RutaDB;//Ruta del archivo de la base de datos.
            AgregarDatos.CargarTablas(dataGridView1);
        }
        /// <summary>
        /// Meto abrir archivo
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void agregarArchivoToolStripMenuItem_(object sender, EventArgs e){
            OpenFileDialog Archivo = new OpenFileDialog();
            Archivo.Filter = "(Archivos pdf y zip)|*.pdf;*.zip";
            Archivo.Title = "Agregar archivo";
            if (Archivo.ShowDialog() == DialogResult.OK) {
                Byte[] BinarioArchiv = new Byte[0];
                FileInfo ArchivoDetalle= new FileInfo(Archivo.FileName);
                BinarioArchiv = File.ReadAllBytes(ArchivoDetalle.FullName);
                BajasaltasSQLITE AgregarDatos = new BajasaltasSQLITE(BinarioArchiv, ArchivoDetalle.Name, ArchivoDetalle.Extension,TipoArchivo(ArchivoDetalle.Extension));
                AgregarDatos.RutaBaseDatos = RutaDB;//Ruta del archivo de la base de datos.
                AgregarDatos.AgregarDatos();
                AgregarDatos.CargarTablas(dataGridView1);
            }
        }

        /// <summary>
        /// Devuelce el tipo de archivo
        /// </summary>
        /// <returns></returns>
        private string TipoArchivo(String Extesion) {
            String Tipo = "";
            switch (Extesion) {
                case ".pdf":
                    Tipo = "Documento de acrobat Adobe";
                    break;
                case ".zip":
                    Tipo = "Documento comprimido";
                    break;
            }
            return Tipo;
        }

        /// <summary>
        /// Guardar archivo a partir de bytes y abrir la misma
        /// </summary>
        public void AbrirArchivo(){
            if (dataGridView1.ColumnCount > 0){
                BajasaltasSQLITE mostrar = new BajasaltasSQLITE();
                mostrar.RutaBaseDatos = RutaDB;
                //Guardamos el archivo donde se genera el ejecutable
                 mostrar.RecuparByt(dataGridView1.SelectedCells[0].Value.ToString(), dataGridView1.SelectedCells[1].Value.ToString());
                try {
                    //Abrimos una  vez guardado el archivo
                    Process.Start(Application.StartupPath + @"\" + dataGridView1.SelectedCells[1].Value.ToString());
                }
                catch (Exception es)
                {
                    MessageBox.Show("Error Instalar ", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }
        /// <summary>
        /// Busca los archivos guardados
        /// en la base de datos
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Txtbuscar_Click(object sender, EventArgs e){
            BajasaltasSQLITE mostrar = new BajasaltasSQLITE();
            mostrar.RutaBaseDatos = RutaDB;
            mostrar.Buscar(dataGridView1, textobuscar.Text);
        }
    }
}
